Index: trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.h2spatial/org.gvsig.h2spatial.h2gis132/org.gvsig.h2spatial.h2gis132.provider/src/test/java/org/gvsig/fmap/dal/store/h2/operations/sql/TestResultSetForSetProvider.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.h2spatial/org.gvsig.h2spatial.h2gis132/org.gvsig.h2spatial.h2gis132.provider/src/test/java/org/gvsig/fmap/dal/store/h2/operations/sql/TestResultSetForSetProvider.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.h2spatial/org.gvsig.h2spatial.h2gis132/org.gvsig.h2spatial.h2gis132.provider/src/test/java/org/gvsig/fmap/dal/store/h2/operations/sql/TestResultSetForSetProvider.java	(revision 46050)
@@ -2,9 +2,14 @@
 
 import java.util.List;
 import junit.framework.TestCase;
+import org.gvsig.expressionevaluator.ExpressionUtils;
+import org.gvsig.fmap.dal.DataTypes;
+import org.gvsig.fmap.dal.feature.EditableFeatureAttributeDescriptor;
+import org.gvsig.fmap.dal.feature.EditableFeatureType;
 import org.gvsig.fmap.dal.feature.FeatureQuery;
 import org.gvsig.fmap.dal.feature.FeatureStore;
 import org.gvsig.fmap.dal.feature.FeatureType;
+import org.gvsig.fmap.dal.impl.expressionevaluator.DefaultFeatureAttributeEmulatorExpression;
 import org.gvsig.fmap.dal.store.h2.TestUtils;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
 import org.gvsig.fmap.dal.store.jdbc2.OperationsFactory;
@@ -65,7 +70,222 @@
     String sql = resultSetForSetProvider.getSQL();
     assertEquals("ResultSetForSetProvider SQL", expectedSQLs.get(0), sql);
   }
+  public void testComputedAttribute() throws Exception {
+     try {
+        JDBCHelper helper = TestUtils.createJDBCHelper();
+        JDBCSQLBuilderBase sqlbuilder = helper.createSQLBuilder();
+        OperationsFactory operations = helper.getOperations();
 
+        List<String> expectedSQLs = TestUtils.getSQLs("resultSetForSetProvider.sql");
+
+        FeatureStore sourceStore = TestUtils.openSourceStore1();
+
+        TableReference table = operations.createTableReference(
+                "dbtest", 
+                sqlbuilder.default_schema(), 
+                "test", 
+                null
+        );
+        FeatureType featureType = sourceStore.getDefaultFeatureType();
+        EditableFeatureType eFeatureType = featureType.getEditable();
+        eFeatureType.add("Compu1", DataTypes.INTEGER, new DefaultFeatureAttributeEmulatorExpression(eFeatureType, ExpressionUtils.createExpression("ID*2")));
+
+        ResultSetForSetProviderOperation resultSetForSetProvider = operations.createResultSetForSetProvider(
+                table,
+                null,
+                null,
+                null,
+                eFeatureType,
+                eFeatureType,
+                0,
+                0, 
+                0
+        );
+        String sql = resultSetForSetProvider.getSQL();
+        assertEquals("ResultSetForSetProvider SQL", expectedSQLs.get(5), sql);
+     } catch (Exception ex) {
+         ex.printStackTrace();
+         throw ex;
+     }
+  }
+  
+  public void testComputedAttribute2() throws Exception {
+     try {
+        JDBCHelper helper = TestUtils.createJDBCHelper();
+        JDBCSQLBuilderBase sqlbuilder = helper.createSQLBuilder();
+        OperationsFactory operations = helper.getOperations();
+
+        List<String> expectedSQLs = TestUtils.getSQLs("resultSetForSetProvider.sql");
+
+        FeatureStore sourceStore = TestUtils.openSourceStore1();
+
+        TableReference table = operations.createTableReference(
+                "dbtest", 
+                sqlbuilder.default_schema(), 
+                "test", 
+                null
+        );
+        FeatureType featureType = sourceStore.getDefaultFeatureType();
+        EditableFeatureType eFeatureType = featureType.getEditable();
+        eFeatureType.add("Compu1", DataTypes.INTEGER, new DefaultFeatureAttributeEmulatorExpression(eFeatureType, ExpressionUtils.createExpression("ID*2")));
+        eFeatureType.add("Compu2", DataTypes.INTEGER, new DefaultFeatureAttributeEmulatorExpression(eFeatureType, ExpressionUtils.createExpression("Long+10+Compu1")));
+
+        ResultSetForSetProviderOperation resultSetForSetProvider = operations.createResultSetForSetProvider(
+                table,
+                null,
+                null,
+                null,
+                eFeatureType,
+                eFeatureType,
+                0,
+                0, 
+                0
+        );
+        String sql = resultSetForSetProvider.getSQL();
+        assertEquals("ResultSetForSetProvider SQL", expectedSQLs.get(6), sql);
+     } catch (Exception ex) {
+         ex.printStackTrace();
+         throw ex;
+     }
+  }
+  
+  public void testComputedExtraColumn() throws Exception {
+     try {
+        JDBCHelper helper = TestUtils.createJDBCHelper();
+        JDBCSQLBuilderBase sqlbuilder = helper.createSQLBuilder();
+        OperationsFactory operations = helper.getOperations();
+
+        List<String> expectedSQLs = TestUtils.getSQLs("resultSetForSetProvider.sql");
+
+        FeatureStore sourceStore = TestUtils.openSourceStore1();
+
+        TableReference table = operations.createTableReference(
+                "dbtest", 
+                sqlbuilder.default_schema(), 
+                "test", 
+                null
+        );
+        FeatureType featureType = sourceStore.getDefaultFeatureType();
+        EditableFeatureType eFeatureType = featureType.getEditable();
+        eFeatureType.add("Compu1", DataTypes.INTEGER, new DefaultFeatureAttributeEmulatorExpression(eFeatureType, ExpressionUtils.createExpression("ID*2")));
+        
+        FeatureQuery query = sourceStore.createFeatureQuery();
+         EditableFeatureAttributeDescriptor extraColumn1 = query.getExtraColumn().add("Extra1", DataTypes.INTEGER);
+        extraColumn1.setFeatureAttributeEmulator(new DefaultFeatureAttributeEmulatorExpression(eFeatureType, ExpressionUtils.createExpression("Long+10+Compu1")));
+
+        ResultSetForSetProviderOperation resultSetForSetProvider = operations.createResultSetForSetProvider(
+                table,
+                null,
+                null,
+                query,
+                eFeatureType,
+                eFeatureType,
+                0,
+                0, 
+                0
+        );
+        String sql = resultSetForSetProvider.getSQL();
+        assertEquals("ResultSetForSetProvider SQL", expectedSQLs.get(7), sql);
+     } catch (Exception ex) {
+         ex.printStackTrace();
+         throw ex;
+     }
+  }
+  
+  public void testComputedExtraColumn2() throws Exception {
+     try {
+        JDBCHelper helper = TestUtils.createJDBCHelper();
+        JDBCSQLBuilderBase sqlbuilder = helper.createSQLBuilder();
+        OperationsFactory operations = helper.getOperations();
+
+        List<String> expectedSQLs = TestUtils.getSQLs("resultSetForSetProvider.sql");
+
+        FeatureStore sourceStore = TestUtils.openSourceStore1();
+
+        TableReference table = operations.createTableReference(
+                "dbtest", 
+                sqlbuilder.default_schema(), 
+                "test", 
+                null
+        );
+        FeatureType featureType = sourceStore.getDefaultFeatureType();
+        EditableFeatureType eFeatureType = featureType.getEditable();
+        
+        FeatureQuery query = sourceStore.createFeatureQuery();
+        EditableFeatureAttributeDescriptor extraColumn1 = query.getExtraColumn().add("Extra1", DataTypes.INTEGER);
+        extraColumn1.setFeatureAttributeEmulator(new DefaultFeatureAttributeEmulatorExpression(eFeatureType, ExpressionUtils.createExpression("ID*2")));
+        EditableFeatureAttributeDescriptor extraColumn2 = query.getExtraColumn().add("Extra2", DataTypes.INTEGER);
+        extraColumn2.setFeatureAttributeEmulator(new DefaultFeatureAttributeEmulatorExpression(eFeatureType, ExpressionUtils.createExpression("Long+10+Extra1")));
+
+        ResultSetForSetProviderOperation resultSetForSetProvider = operations.createResultSetForSetProvider(
+                table,
+                null,
+                null,
+                query,
+                eFeatureType,
+                eFeatureType,
+                0,
+                0, 
+                0
+        );
+        String sql = resultSetForSetProvider.getSQL();
+        assertEquals("ResultSetForSetProvider SQL", expectedSQLs.get(8), sql);
+     } catch (Exception ex) {
+         ex.printStackTrace();
+         throw ex;
+     }
+  }
+  
+public void testComputedExtraColumnWithWhere() throws Exception {
+     try {
+        JDBCHelper helper = TestUtils.createJDBCHelper();
+        JDBCSQLBuilderBase sqlbuilder = helper.createSQLBuilder();
+        OperationsFactory operations = helper.getOperations();
+
+        List<String> expectedSQLs = TestUtils.getSQLs("resultSetForSetProvider.sql");
+
+        FeatureStore sourceStore = TestUtils.openSourceStore1();
+
+        TableReference table = operations.createTableReference(
+                "dbtest", 
+                sqlbuilder.default_schema(), 
+                "test", 
+                null
+        );
+        
+        StringBuilder filter = new StringBuilder();
+        filter.append("Extra1 > 10");
+    
+        FeatureType featureType = sourceStore.getDefaultFeatureType();
+        
+        EditableFeatureType eFeatureType = featureType.getEditable();
+        eFeatureType.add("Compu1", DataTypes.INTEGER, new DefaultFeatureAttributeEmulatorExpression(eFeatureType, ExpressionUtils.createExpression("ID*2")));
+        
+        FeatureQuery query = sourceStore.createFeatureQuery();
+        EditableFeatureAttributeDescriptor extraColumn1 = query.getExtraColumn().add("Extra1", DataTypes.INTEGER);
+        extraColumn1.setFeatureAttributeEmulator(new DefaultFeatureAttributeEmulatorExpression(eFeatureType, ExpressionUtils.createExpression("Long+10+Compu1")));
+        query.addFilter(filter.toString());
+        query.getOrder().add("Extra1");
+
+        ResultSetForSetProviderOperation resultSetForSetProvider = operations.createResultSetForSetProvider(
+                table,
+                null,
+                null,
+                query,
+                eFeatureType,
+                eFeatureType,
+                0,
+                0, 
+                0
+        );
+        String sql = resultSetForSetProvider.getSQL();
+        assertEquals("ResultSetForSetProvider SQL", expectedSQLs.get(9), sql);
+     } catch (Exception ex) {
+         ex.printStackTrace();
+         throw ex;
+     }
+  }
+
     public void testSimpleGroup() throws Exception {
         try {
             JDBCHelper helper = TestUtils.createJDBCHelper();
@@ -108,7 +328,61 @@
             throw th;
         }
     }
+    
+    public void testGroupByComputed() throws Exception {
+        try {
+            JDBCHelper helper = TestUtils.createJDBCHelper();
+            JDBCSQLBuilderBase sqlbuilder = helper.createSQLBuilder();
+            OperationsFactory operations = helper.getOperations();
 
+            List<String> expectedSQLs = TestUtils.getSQLs("resultSetForSetProvider.sql");
+
+            FeatureStore sourceStore = TestUtils.openSourceStore1();
+
+            TableReference table = operations.createTableReference(
+                    "dbtest",
+                    sqlbuilder.default_schema(),
+                    "test",
+                    null
+            );
+            FeatureType featureType = sourceStore.getDefaultFeatureType();
+            FeatureQuery query = sourceStore.createFeatureQuery();
+            EditableFeatureType eFeatureType = featureType.getEditable();
+            eFeatureType.add("Compu1", DataTypes.INTEGER, new DefaultFeatureAttributeEmulatorExpression(eFeatureType, ExpressionUtils.createExpression("ID*2")));
+            eFeatureType.add("Compu2", DataTypes.INTEGER, new DefaultFeatureAttributeEmulatorExpression(eFeatureType, ExpressionUtils.createExpression("Long+300")));
+            EditableFeatureAttributeDescriptor extraColumn1 = query.getExtraColumn().add("Extra1", DataTypes.INTEGER);
+            EditableFeatureAttributeDescriptor extraColumn2 = query.getExtraColumn().add("Extra2", DataTypes.INTEGER);
+            extraColumn1.setFeatureAttributeEmulator(new DefaultFeatureAttributeEmulatorExpression(eFeatureType, ExpressionUtils.createExpression("Long+10+Compu1")));
+            extraColumn2.setFeatureAttributeEmulator(new DefaultFeatureAttributeEmulatorExpression(eFeatureType, ExpressionUtils.createExpression("20+Byte+Compu1")));
+            query.getGroupByColumns().add("Long");
+            query.getGroupByColumns().add("Extra1");
+            query.getGroupByColumns().add("Compu1");
+            query.getAggregateFunctions().put("ID", "MIN");
+            query.getAggregateFunctions().put("Byte", "MAX");
+            query.getAggregateFunctions().put("Double", "SUM");
+            query.getAggregateFunctions().put("Extra2", "SUM");
+            query.getAggregateFunctions().put("Compu2", "SUM");
+            ResultSetForSetProviderOperation resultSetForSetProvider = operations.createResultSetForSetProvider(
+                    table,
+                    null,
+                    null,
+                    query,
+                    eFeatureType,
+                    eFeatureType,
+                    0,
+                    0,
+                    0
+            );
+            String sql = resultSetForSetProvider.getSQL();
+            System.out.println("###### SQL:" + sql);
+            System.out.println("###### EXP:" + expectedSQLs.get(10));
+
+            assertEquals("ResultSetForSetProvider SQL", expectedSQLs.get(10), sql);
+        } catch (Throwable th) {
+            throw th;
+        }
+    }
+
   public void testSubselect() throws Exception {
     JDBCHelper helper = TestUtils.createJDBCHelper();
     JDBCSQLBuilderBase sqlbuilder = helper.createSQLBuilder();
